/// <reference types="winston" />
import * as winston from 'winston';
export interface Response {
    headers: {
        [id: string]: string;
    };
    statusCode: number;
}
export interface Request {
    on(a: 'error', cb: (err: Error) => void): void;
    on(a: 'data', cb: (data: string) => void): void;
    on(a: 'complete', cb: (resp: Response) => void): void;
}
export declare class Config {
    urls: string[];
    reqTimeout: number;
    retries: number;
    waitTime: number;
    clusterId: string;
    appId: string;
    log: winston.LoggerInstance;
    request: (o: any) => Request;
    static start(argv: string[], app?: string): Config;
    setRequest(req: (o: any) => Request): Config;
}
export default Config;
