import { Config } from './config';
import ChangeWaiter from './change-waiter';
import SelfState from './self-state';
import EtcResponse from './etc-response';
import EtcValue from './etc-value';
import EtcValueNode from './etc-value-node';
import * as upset from './upset';
import * as rx from 'rxjs';
export declare class EtcdObservable {
    cfg: Config;
    private connected?;
    private selfStateInActions;
    static create(cfg: Config): EtcdObservable;
    constructor(cfg: Config);
    private etcdRequest(method, url, options?);
    private rawRequest(method, url, options?);
    private urlParams(params, sep?);
    private bodyParams(params);
    private buildKeyUri(base, key);
    untilFirstConnect(): rx.Observable<SelfState[]>;
    private retryConnect(obs, retry);
    connect(): rx.Observable<SelfState>;
    clusterState(): rx.Observable<SelfState[]>;
    private resolvSelfStateInActions(url, s2);
    selfStat(url: string): rx.Observable<SelfState>;
    private keyAction(method, key, options?);
    update(key: string, ttl: number): rx.Observable<EtcResponse>;
    addQueue(key: string, val: string, ttl: number): rx.Observable<EtcResponse>;
    mkdir(key: string): rx.Observable<EtcResponse>;
    rmdir(key: string, params?: any): rx.Observable<EtcResponse>;
    delete(key: string): rx.Observable<EtcResponse>;
    list(key: string, params?: any): rx.Observable<EtcValue<EtcValueNode[]>>;
    getRaw(key: string, params?: any, options?: any): rx.Observable<EtcResponse>;
    getString(key: string, params?: any): rx.Observable<EtcValue<string>>;
    getJson(key: string, params?: any): rx.Observable<EtcValue<any>>;
    setRaw(key: string, val: string, params?: any): rx.Observable<EtcResponse>;
    setJson(key: string, val: any, params?: any): rx.Observable<EtcResponse>;
    createChangeWaiter(path: string, params?: any, options?: any): ChangeWaiter;
    createUpset(key: string, apply: upset.Apply): rx.Observable<void>;
}
export default EtcdObservable;
